local name, addon = ...
local sbt,scbt = Minimap.SetBlipTexture,Minimap.SetClassBlipTexture
local f = CreateFrame("Frame")
local db
local itsme = false
local function SetBlipTexture(self, file)
	if not itsme then geterrorhandler()("Something's overwriting the BlipTexture. :(") end
    sbt(self, file)
end

local function SetClassBlipTexture(self, file)
    if not itsme then geterrorhandler()("Something's overwriting the ClassBlipTexture. :(") end
    scbt(self, file)
end

local function switch()
	local n = ""
	if(db['switch'] == 1) then
		n = "3"
	elseif(db['switch'] == 2) then
		n = "2"
	else
		db['switch'] = 3
		n = ""
	end
	itsme = true
	Minimap:SetBlipTexture("Interface\\AddOns\\"..name.."\\OBJECTICONS"..n..".tga")
	Minimap:SetClassBlipTexture("Interface\\AddOns\\"..name.."\\PartyRaidBlips"..n..".tga")
	itsme = db['debug']
end

local function init(self, event, arg1)
	if(arg1 ~= name) then return end
	DisableMinimapTargetDB = DisableMinimapTargetDB or {
		['debug'] = false,
		['switch'] = 2,
	}
	db = DisableMinimapTargetDB 
	switch()
	Minimap.SetBlipTexture,Minimap.SetClassBlipTexture = SetBlipTexture, SetClassBlipTexture
	self:SetScript("OnEvent", nil)
end

local function print(...)
	local s = ""
	for _,v in ipairs({...}) do
		s = format("%s %s",s,tostring(v))
	end
	s = strsub(s,2)
	SELECTED_CHAT_FRAME:AddMessage(format("|c00883388DMT|r %s",s))
end

local function slash(msg, editbox)
	msg = strlower(msg)
	if(msg == "debug") then
		db['debug'] = not db['debug']
		print("debug",db['debug'] and "enabled" or "disabled")
	elseif(msg == "help" or msg == "") then
		print("/setdmt 1 -- Disable Targetcross/Focuscircle and blips")
		print("/setdmt 2 -- Disable Targetcross/Focuscircle (Default)")
		print("/setdmt 3 -- Disable Targetcross")
		print("/setdmt debug -- Toggle debug")
	else
		db['switch'] = tonumber(msg)
		switch()
	end
end

_G["SLASH_"..name.."1"] = "/setdmt"
SlashCmdList[name] = slash

f:SetScript("OnEvent", init)
f:RegisterEvent("ADDON_LOADED")

